	SUBROUTINE PHGRPH(XMN,XLAM,XPHI,MNAUF,NK)

********************************************************************
*                                                                  *
*                     Author: L. HAIMBERGER                        *
*                     2000-12-11                                   *
*                     adapted: A. BECK                             *
*                     2003-05-11                                   *
*                                                                  *
********************************************************************

	IMPLICIT NONE
	
	INTEGER MNAUF,NK,K,M,N
	INTEGER INDEX,INDEXV,INDEXN

	REAL*8 XMN(0:(MNAUF+1)*(MNAUF+2)-1,NK)
	REAL*8 XLAM(0:(MNAUF+1)*(MNAUF+2)-1,NK)
	REAL*8 XPHI(0:(MNAUF+1)*(MNAUF+2)-1,NK)
	
	REAL*8 ERAD
	
	REAL*8 EPS,EPS1
	
	ERAD= 6371000.0
	
	DO 3 K=1,NK
		DO 2 M = 0,MNAUF
			INDEX = (M*(M+1))/2
			DO 1 N = M,MNAUF
			  INDEXV=INDEX
				INDEX = INDEX+N
				INDEXN=INDEX+1+N
				EPS=SQRT(FLOAT(N*N-M*M)/FLOAT(4*N*N-1))
				EPS1=SQRT(FLOAT((N+1)*(N+1)-M*M)/FLOAT(4*(N+1)*(N+1)-1))
				IF(N.LE.MNAUF) THEN
					XLAM(2*INDEX,K) = -M*XMN(2*INDEX+1,K)/ERAD
					XLAM(2*INDEX+1,K) = M*XMN(2*INDEX,K)/ERAD
				ENDIF
				IF(N.LT.MNAUF) THEN
					 XPHI(2*INDEX,K) = -((N-1)*EPS*XMN(2*INDEXV,K)-
     *(N+2)*EPS1*XMN(2*INDEXN,K))/ERAD
					 XPHI(2*INDEX+1,K) = -((N-1)*EPS*XMN(2*INDEXV+1,K)-
     *(N+2)*EPS1*XMN(2*INDEXN+1,K))/ERAD
				ELSE
					 XPHI(2*INDEX,K) = 
     *-((N-1)*EPS*XMN(2*INDEXV,K))/ERAD
					 XPHI(2*INDEX+1,K) = 
     *-((N-1)*EPS*XMN(2*INDEXV+1,K))/ERAD
				ENDIF
1			CONTINUE
2		CONTINUE
3	CONTINUE
	RETURN
	END
	
	SUBROUTINE CONTGL(PS,DPSDL,DPSDM,DIV,U,V,BREITE,ETA,NI,NJ,NK,A,B)
				
	IMPLICIT NONE
	
	INTEGER NI,NJ,NK,I,J,K
	
	REAL*8 A(NK+1),B(NK+1)
	REAL*8 PS(NI,NJ),DPSDL(NI,NJ),DPSDM(NI,NJ)
	REAL*8 DIV(NI,NJ,NK),U(NI,NJ,NK),V(NI,NJ,NK),ETA(NI,NJ,NK)
	REAL*8 BREITE(NJ)
	
	REAL*8 DIVT1,DIVT2,POB,PUN,DPSDT,COSB
	
	DO 4 J=1,NJ
C		COSB=SQRT(1.0-BREITE(J)*BREITE(J))
		DO 3 I=1,NI
			DIVT1=0.0
			DIVT2=0.0
			DO 1 K=1,NK
				POB=A(K)+B(K)*PS(I,J)
				PUN=A(K+1)+B(K+1)*PS(I,J)
				
				DIVT1=DIVT1+DIV(I,J,K)*(PUN-POB)
				DIVT2=DIVT2+(B(K+1)-B(K))*PS(I,J)*
     *(U(I,J,K)*DPSDL(I,J)+V(I,J,K)*DPSDM(I,J))/
     *(1.0-BREITE(J)*BREITE(J))
     
     		ETA(I,J,K)=-DIVT1-DIVT2
1			CONTINUE

			DPSDT=(-DIVT1-DIVT2)/PS(I,J)
			
			DO 2 K=1,NK
				ETA(I,J,K)=ETA(I,J,K)-DPSDT*B(K+1)*PS(I,J)
2			CONTINUE
			PS(I,J)=DPSDT*PS(I,J)
3		CONTINUE
4	CONTINUE
	RETURN
	END
	
